unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, DBGrids, ExtCtrls, DB, DBTables, XPMan, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    XPManifest1: TXPManifest;
    qryEmployee: TQuery;
    qryEmployeeLastName: TStringField;
    qryEmployeeHireDate: TDateTimeField;
    qryEmployeeSalary: TFloatField;
    dsEmployee: TDataSource;
    Panel1: TPanel;
    DBGrid1: TDBGrid;
    btnSoma: TBitBtn;
    Panel2: TPanel;
    Label1: TLabel;
    edtResultSoma: TEdit;
    procedure btnSomaClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btnSomaClick(Sender: TObject);
var
  i : Integer;
  sum : Double;
begin
  if DBGrid1.SelectedRows.Count > 0 then
  begin
    sum := 0;
    with DBGrid1.DataSource.DataSet do
    begin
      for i := 0 to DBGrid1.SelectedRows.Count-1 do
      begin
        GotoBookmark(Pointer(DBGrid1.SelectedRows.Items[i]));
        sum:= sum + qryEmployee.FieldByName('Salary').AsCurrency;
      end;
    end;
    edtResultSoma.Text := Format('%m', [sum]);
    // Com a funo Format, o resultado  formatado para o tipo Money
    // Voc poderia ter escrito, ao invs: FloatToStr(Sum) que teria
    // o valor puro do clculo sem os caracteres de moeda.
  end
end;


end.
