unit uClassDefs;

interface

uses VBScript_RegExp_55_TLB;

type
  TAcerto = class
  private
    FMatch : Match;
  public
    constructor Create(AMatch : Match);
    destructor Destroy; override;
    function Texto : string;
    function Posicao : integer;
    function Tamanho : integer;
    function SubAcertos : SubMatches;
  end;

implementation

{ TAcerto }

constructor TAcerto.Create(AMatch : Match);
begin
  FMatch := AMatch;
end;

destructor TAcerto.Destroy;
begin
  FMatch := nil;
  inherited;
end;

function TAcerto.Posicao: integer;
begin
  result := -1;
  if assigned(FMatch) then
    result := FMatch.FirstIndex;
end;

function TAcerto.SubAcertos: SubMatches;
begin
  result := nil;
  if assigned(FMatch) then
    result := FMatch.SubMatches as SubMatches;
end;

function TAcerto.Tamanho: integer;
begin
  result := -1;
  if assigned(FMatch) then
    Result := FMatch.Length;
end;

function TAcerto.Texto: string;
begin
  result := '';
  if assigned(FMatch) then
    Result := FMatch.Value;
end;

end.
