unit uPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus;

type
  TFrmPrincipal = class(TForm)
    MainMenu1: TMainMenu;
    Cadastro1: TMenuItem;
    Movimentacao1: TMenuItem;
    Graficos1: TMenuItem;
    Sair1: TMenuItem;
    Clientes1: TMenuItem;
    Produtos1: TMenuItem;
    Familias1: TMenuItem;
    Pedidos1: TMenuItem;
    procedure Clientes1Click(Sender: TObject);
    procedure Sair1Click(Sender: TObject);
    procedure Familias1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmPrincipal: TFrmPrincipal;

implementation

uses uClientes, uFrmFamiliaProduto;

{$R *.dfm}

procedure TFrmPrincipal.Clientes1Click(Sender: TObject);
begin
  try
    FrmClientes := TFrmClientes.create(self);
    FrmClientes.ShowModal;
  finally
    FreeandNil(FrmClientes);
  end;
end;

procedure TFrmPrincipal.Sair1Click(Sender: TObject);
begin
  Close;
end;

procedure TFrmPrincipal.Familias1Click(Sender: TObject);
begin
  try
    FrmFamiliaProduto := TFrmFamiliaProduto.create(self);
    FrmFamiliaProduto.ShowModal;
  finally
    FreeandNil(FrmFamiliaProduto);
  end;
end;

end.

